<?php
namespace Ep\TecDoc\Form\Element;

use Ep\TecDoc\TecDocInterface;
use Laminas\Form\Element\Select;

/**
 * Class VehicleManufacturer
 *
 * @package Ep\TecDoc\Form\Element
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleManufacturer extends Select
{
    protected TecDocInterface $tecdoc;

    public function __construct(TecDocInterface $tecdoc, $name = null, array $options = [])
    {
        $this->tecdoc = $tecdoc;

        parent::__construct($name, $options);
    }

    public function getValueOptions(): array
    {
        if (empty($this->valueOptions)) {
            $this->valueOptions = [];
            $manufacturers = $this->tecdoc->getManufacturers();

            foreach ($manufacturers as $manufacturer) {
                $this->valueOptions[$manufacturer->getId()] = $manufacturer->getName();
            }
        }
        return parent::getValueOptions();
    }
}
